<?xml version="1.0" encoding="UTF-8"?>
<jasperReport xmlns="http://jasperreports.sourceforge.net/jasperreports" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://jasperreports.sourceforge.net/jasperreports http://jasperreports.sourceforge.net/xsd/jasperreport.xsd" name="RelatorioContaGerencial" language="groovy" pageWidth="595" pageHeight="842" columnWidth="555" leftMargin="20" rightMargin="20" topMargin="20" bottomMargin="20" uuid="ea79b07a-237b-46f2-804a-f6c33ea001ed">
	<property name="ireport.zoom" value="4.287177620000003"/>
	<property name="ireport.x" value="0"/>
	<property name="ireport.y" value="144"/>
	<parameter name="MOSTRAR_DETALHE" class="java.lang.String">
		<defaultValueExpression><![CDATA[N]]></defaultValueExpression>
	</parameter>
	<parameter name="DATA_INICIAL" class="java.lang.String"/>
	<parameter name="DATA_FINAL" class="java.lang.String"/>
	<parameter name="TIPO_RELATORIO" class="java.lang.String"/>
	<queryString>
		<![CDATA[(select contaPagar.idLancamentoContaPagar as documento, contaPagar.valorOriginal, fornecedor.razaoSocial as origem, 'P' as tipo, contaPagar.dataLancamento as dataLancamento, contaGer.descricao,
contaGer.codigoContaNivel1 as nivel1, contaGer.codigoContaNivel2 as nivel2, contaGer.codigoContaNivel3 as nivel3,

IF(LENGTH(contaGer.contaContabil) - LENGTH(REPLACE(contaGer.contaContabil, '.', '')) = 1,'2',
IF(LENGTH(contaGer.contaContabil) - LENGTH(REPLACE(contaGer.contaContabil, '.', '')) = 2, '3', '1')) as nivel,

calculaContaPaiContaGerencial(contaContabil) as contaPai,

COALESCE(IF(LENGTH(calculaContaPaiContaGerencial(contaGer.contaContabil)) < 2, calculaValorTotalContaGerencial(contaContabil, '2014-01-01 00:00:00', '2014-02-06 00:00:00', IF(contaGer.codigoContaNivel2 is null, '1', '2')), 0), 0) as valorTotal,

contaGer.contaContabil

from lancamentoContaPagar as contaPagar
LEFT OUTER JOIN fornecedor fornecedor ON contaPagar.idFornecedor = fornecedor.idFornecedor
INNER JOIN contaGerencial contaGer ON  contaPagar.idContaGerencial = contaGer.idContaGerencial
where contaPagar.dataLancamento between '2014-01-01 00:00:00' and '2014-02-06 00:00:00')

UNION

(select contaReceber.idLancamentoContareceber as documento, contaReceber.valorOriginal, cliente.nome as origem, 'R' as tipo, contaReceber.dataLancamento as dataLancamento, contaGer.descricao,
contaGer.codigoContaNivel1 as nivel1, contaGer.codigoContaNivel2 as nivel2, contaGer.codigoContaNivel3 as nivel3,

IF(LENGTH(contaGer.contaContabil) - LENGTH(REPLACE(contaGer.contaContabil, '.', '')) = 1,'2',
IF(LENGTH(contaGer.contaContabil) - LENGTH(REPLACE(contaGer.contaContabil, '.', '')) = 2, '3', '1')) as nivel,

calculaContaPaiContaGerencial(contaGer.contaContabil) as contaPai ,

COALESCE(IF(LENGTH(calculaContaPaiContaGerencial(contaGer.contaContabil)) < 2, calculaValorTotalContaGerencial(contaContabil, '2014-01-01 00:00:00', '2014-02-06 00:00:00', IF(contaGer.codigoContaNivel2 is null, '1', '2')), 0), 0) as valorTotal,

contaGer.contaContabil

from lancamentoContaReceber as contaReceber
LEFT OUTER JOIN cliente cliente ON contaReceber.idCliente = cliente.idCliente
INNER JOIN contaGerencial contaGer ON  contaReceber.idContaGerencial = contaGer.idContaGerencial
where contaReceber.dataLancamento between '2014-01-01 00:00:00' and '2014-02-06 00:00:00')

UNION

(select '' as documento, 0 as valorOriginal, null as origem, 'N' as tipo, '2014-01-01' as dataLancamento, contaGer.descricao,
contaGer.codigoContaNivel1 as nivel1, contaGer.codigoContaNivel2 as nivel2, contaGer.codigoContaNivel3 as nivel3,

IF(LENGTH(contaGer.contaContabil) - LENGTH(REPLACE(contaGer.contaContabil, '.', '')) = 1,'2',
IF(LENGTH(contaGer.contaContabil) - LENGTH(REPLACE(contaGer.contaContabil, '.', '')) = 2, '3', '1')) as nivel,

calculaContaPaiContaGerencial(contaGer.contaContabil) as contaPai,

COALESCE(IF(LENGTH(calculaContaPaiContaGerencial(contaGer.contaContabil)) < 2, calculaValorTotalContaGerencial(contaContabil, '2014-01-01 00:00:00', '2014-02-06 00:00:00', IF(contaGer.codigoContaNivel2 is null, '1', '2')), 0), 0) as valorTotal,

contaGer.contaContabil

from ContaGerencial as contaGer
where contaGer.idContaGerencial not in
(select idcontaGerencial from lancamentoContaPagar lancamentoContaPagarContaGerencial
where lancamentoContaPagarContaGerencial.dataLancamento between '2014-01-01 00:00:00' and '2014-02-06 00:00:00')
and contaGer.idContaGerencial not in
(select idcontaGerencial from lancamentoContaReceber lancamentoContaReceberContaGerencial
where lancamentoContaReceberContaGerencial.dataLancamento between '2014-01-01 00:00:00' and '2014-02-06 00:00:00')
)

order by nivel1, nivel2, nivel3, origem]]>
	</queryString>
	<field name="valorOriginal" class="java.lang.Double">
		<fieldDescription><![CDATA[valorOriginal:Valor Original]]></fieldDescription>
	</field>
	<field name="origem" class="java.lang.String">
		<fieldDescription><![CDATA[origem:Origem]]></fieldDescription>
	</field>
	<field name="tipo" class="java.lang.String">
		<fieldDescription><![CDATA[tipo:Tipo]]></fieldDescription>
	</field>
	<field name="dataLancamento" class="java.sql.Date">
		<fieldDescription><![CDATA[dataLancamento:Dt. Lançamento]]></fieldDescription>
	</field>
	<field name="descricao" class="java.lang.String">
		<fieldDescription><![CDATA[descricao:Descrição]]></fieldDescription>
	</field>
	<field name="nivel" class="java.lang.String"/>
	<field name="contaPai" class="java.lang.String"/>
	<field name="contaContabil" class="java.lang.String">
		<fieldDescription><![CDATA[contaContabil:Conta Contabil]]></fieldDescription>
	</field>
	<field name="valorTotal" class="java.lang.Double"/>
	<variable name="valorTotalNivel3" class="java.lang.Double" resetType="Group" resetGroup="ContaNivel3" calculation="Sum">
		<variableExpression><![CDATA[$F{valorOriginal}]]></variableExpression>
	</variable>
	<variable name="valorTotalNivel2" class="java.lang.Double" resetType="Group" resetGroup="ContaNivel3" calculation="Sum">
		<variableExpression><![CDATA[$V{valorTotalNivel3}]]></variableExpression>
	</variable>
	<group name="ContaNivel1">
		<groupExpression><![CDATA[$F{contaContabil}]]></groupExpression>
		<groupHeader>
			<band height="10">
				<printWhenExpression><![CDATA[$F{nivel}.equals("1")]]></printWhenExpression>
				<textField>
					<reportElement uuid="6cda29c9-f61d-479f-b309-72adef297142" x="0" y="0" width="297" height="10"/>
					<textElement>
						<font size="7" isBold="true"/>
					</textElement>
					<textFieldExpression><![CDATA[$F{contaContabil} + "  " + $F{descricao}]]></textFieldExpression>
				</textField>
				<line>
					<reportElement uuid="f0f2259e-8e4f-4d20-8e31-b2a3d1ca0f52" x="0" y="9" width="555" height="1"/>
					<graphicElement>
						<pen lineWidth="0.5"/>
					</graphicElement>
				</line>
				<textField pattern="#,##0.00">
					<reportElement uuid="6db9849a-f3d6-4f0c-b1b6-dc305f47ef55" x="368" y="-1" width="58" height="10"/>
					<textElement textAlignment="Right">
						<font size="7" isBold="true"/>
					</textElement>
					<textFieldExpression><![CDATA[$F{valorTotal}]]></textFieldExpression>
				</textField>
				<staticText>
					<reportElement uuid="1eb4bb11-6e45-40ed-b08f-8defd63d7606" x="337" y="-1" width="25" height="10"/>
					<textElement textAlignment="Right">
						<font size="7" isBold="true"/>
					</textElement>
					<text><![CDATA[Total :]]></text>
				</staticText>
			</band>
		</groupHeader>
	</group>
	<group name="ContaNivel2">
		<groupExpression><![CDATA[$F{contaContabil}]]></groupExpression>
		<groupHeader>
			<band height="10" splitType="Prevent">
				<printWhenExpression><![CDATA[$F{nivel}.equals("2")]]></printWhenExpression>
				<textField>
					<reportElement uuid="ec260f71-1ac3-49bb-90b5-ffe2a1f84482" x="15" y="0" width="297" height="10"/>
					<textElement>
						<font size="7" isBold="true"/>
					</textElement>
					<textFieldExpression><![CDATA[$F{contaContabil} + "  " + $F{descricao}]]></textFieldExpression>
				</textField>
				<textField pattern="#,##0.00">
					<reportElement uuid="e061b308-350c-4bd6-95c4-66c3ed5f47e5" x="365" y="0" width="61" height="10"/>
					<textElement textAlignment="Right">
						<font size="7" isBold="true"/>
					</textElement>
					<textFieldExpression><![CDATA[$F{valorTotal}]]></textFieldExpression>
				</textField>
				<staticText>
					<reportElement uuid="5b3c4a06-3402-4c07-88bf-54c5fce87481" x="334" y="0" width="28" height="10"/>
					<textElement textAlignment="Right">
						<font size="7" isBold="true"/>
					</textElement>
					<text><![CDATA[Total :]]></text>
				</staticText>
			</band>
		</groupHeader>
		<groupFooter>
			<band splitType="Immediate">
				<printWhenExpression><![CDATA[$F{nivel}.equals("2")]]></printWhenExpression>
			</band>
		</groupFooter>
	</group>
	<group name="ContaNivel3" keepTogether="true">
		<groupExpression><![CDATA[$F{contaContabil}]]></groupExpression>
		<groupHeader>
			<band height="12">
				<printWhenExpression><![CDATA[$F{nivel}.equals("3") && $P{MOSTRAR_DETALHE}.equals("S")]]></printWhenExpression>
				<line>
					<reportElement uuid="cb1a3ef5-8345-4edb-aced-128a2dcf1fae" x="37" y="11" width="518" height="1"/>
					<graphicElement>
						<pen lineWidth="0.5"/>
					</graphicElement>
				</line>
				<textField>
					<reportElement uuid="f4860670-0e5f-4023-a11a-fdd12c58b3ad" x="37" y="1" width="297" height="10">
						<printWhenExpression><![CDATA[$P{MOSTRAR_DETALHE}.equals("S")]]></printWhenExpression>
					</reportElement>
					<textElement>
						<font size="7" isBold="false"/>
					</textElement>
					<textFieldExpression><![CDATA[$F{contaContabil} + "  " + $F{descricao}]]></textFieldExpression>
				</textField>
				<staticText>
					<reportElement uuid="2b23b2b2-2439-4c61-8b2b-e27e8d15d783" x="334" y="0" width="28" height="10"/>
					<textElement textAlignment="Right">
						<font size="7"/>
					</textElement>
					<text><![CDATA[Total :]]></text>
				</staticText>
				<textField evaluationTime="Group" evaluationGroup="ContaNivel3" pattern="#,##0.00">
					<reportElement uuid="c72cd9df-7f5d-4129-88e7-38baa7933d8e" x="365" y="0" width="61" height="10"/>
					<textElement textAlignment="Right">
						<font size="7" isBold="false"/>
					</textElement>
					<textFieldExpression><![CDATA[$V{valorTotalNivel3}]]></textFieldExpression>
				</textField>
				<line>
					<reportElement uuid="d55680db-04c6-4938-8e51-d4223938a9e0" x="15" y="0" width="540" height="1"/>
					<graphicElement>
						<pen lineWidth="0.5" lineStyle="Solid"/>
					</graphicElement>
				</line>
			</band>
		</groupHeader>
		<groupFooter>
			<band height="10">
				<printWhenExpression><![CDATA[$F{nivel}.equals("3") && !$P{MOSTRAR_DETALHE}.equals("S")]]></printWhenExpression>
				<textField evaluationTime="Group" evaluationGroup="ContaNivel3" pattern="#,##0.00">
					<reportElement uuid="6e2934be-0f30-447a-ac06-c5f8bd96cbae" x="365" y="0" width="61" height="10"/>
					<textElement textAlignment="Right">
						<font size="7" isBold="false"/>
					</textElement>
					<textFieldExpression><![CDATA[$V{valorTotalNivel3}]]></textFieldExpression>
				</textField>
				<staticText>
					<reportElement uuid="aea2d64c-e8c1-4860-9674-6bd6c247cf2b" x="334" y="0" width="28" height="10"/>
					<textElement textAlignment="Right">
						<font size="7"/>
					</textElement>
					<text><![CDATA[Total :]]></text>
				</staticText>
				<textField>
					<reportElement uuid="67aa4ded-a70c-46a3-aeaf-5002f7a66e76" x="37" y="0" width="297" height="10"/>
					<textElement>
						<font size="7" isBold="false"/>
					</textElement>
					<textFieldExpression><![CDATA[$F{contaContabil} + "  " + $F{descricao}]]></textFieldExpression>
				</textField>
			</band>
		</groupFooter>
	</group>
	<background>
		<band splitType="Stretch"/>
	</background>
	<title>
		<band splitType="Stretch"/>
	</title>
	<pageHeader>
		<band height="20" splitType="Stretch">
			<staticText>
				<reportElement uuid="9118c0c1-feb8-4255-8cb9-abf29f898240" x="0" y="0" width="143" height="20"/>
				<textElement>
					<font isBold="true"/>
				</textElement>
				<text><![CDATA[Relatório Plano de Contas]]></text>
			</staticText>
			<staticText>
				<reportElement uuid="816e4692-e4a9-44fe-9736-6388f76de960" x="412" y="0" width="58" height="10"/>
				<textElement textAlignment="Right">
					<font size="7"/>
				</textElement>
				<text><![CDATA[Relatório : ]]></text>
			</staticText>
			<staticText>
				<reportElement uuid="1803a5b7-4229-495a-91bf-e3c92ba61e10" x="412" y="9" width="58" height="10"/>
				<textElement textAlignment="Right">
					<font size="7"/>
				</textElement>
				<text><![CDATA[Tipo Relatório :]]></text>
			</staticText>
			<staticText>
				<reportElement uuid="489d386a-01a1-4859-b4a6-c062e00bd72e" x="302" y="0" width="40" height="10"/>
				<textElement textAlignment="Right">
					<font size="7"/>
				</textElement>
				<text><![CDATA[Data Inicial :]]></text>
			</staticText>
			<staticText>
				<reportElement uuid="e3ab7d25-ce83-4d52-aad9-695fb698a852" x="302" y="9" width="40" height="10"/>
				<textElement textAlignment="Right">
					<font size="7"/>
				</textElement>
				<text><![CDATA[Data Final :]]></text>
			</staticText>
			<textField>
				<reportElement uuid="64a8c3f8-2a30-4fb3-bd6b-69bab8552837" x="472" y="0" width="83" height="10"/>
				<textElement>
					<font size="7"/>
				</textElement>
				<textFieldExpression><![CDATA[$P{MOSTRAR_DETALHE}.equals("S") ? "Analítico" : "Sintético"]]></textFieldExpression>
			</textField>
			<textField>
				<reportElement uuid="6967309c-0ca4-427f-8abe-17bff421eb39" x="472" y="9" width="83" height="10"/>
				<textElement>
					<font size="7"/>
				</textElement>
				<textFieldExpression><![CDATA[$P{TIPO_RELATORIO}.equals("1") ? "Contas a Pagar/Receber" : "Contas Pagas/Recebidas"]]></textFieldExpression>
			</textField>
			<textField>
				<reportElement uuid="9b08e07e-fdcb-4eec-86cc-b6942c1f44ac" x="343" y="0" width="65" height="10"/>
				<textElement>
					<font size="7"/>
				</textElement>
				<textFieldExpression><![CDATA[$P{DATA_INICIAL}]]></textFieldExpression>
			</textField>
			<textField>
				<reportElement uuid="41b7dc7d-b058-4e95-9898-4c9444d784c2" x="343" y="9" width="65" height="10"/>
				<textElement>
					<font size="7"/>
				</textElement>
				<textFieldExpression><![CDATA[$P{DATA_FINAL}]]></textFieldExpression>
			</textField>
			<line>
				<reportElement uuid="b3c2425b-4269-4a5d-97e7-36ac28f6f075" x="0" y="19" width="555" height="1"/>
				<graphicElement>
					<pen lineWidth="0.5"/>
				</graphicElement>
			</line>
		</band>
	</pageHeader>
	<columnHeader>
		<band splitType="Stretch"/>
	</columnHeader>
	<detail>
		<band height="10" splitType="Stretch">
			<printWhenExpression><![CDATA[!$F{origem}.equals("") && $F{origem} != null && $P{MOSTRAR_DETALHE}.equals("S")]]></printWhenExpression>
			<textField pattern="#,##0.00">
				<reportElement uuid="e64b8e18-8310-4219-b213-cb2d7a812556" x="220" y="0" width="100" height="10"/>
				<textElement>
					<font size="7" isBold="false"/>
				</textElement>
				<textFieldExpression><![CDATA[$F{valorOriginal}]]></textFieldExpression>
			</textField>
			<textField isBlankWhenNull="true">
				<reportElement uuid="118a904e-91fd-446a-af72-02fb6356db6a" x="56" y="0" width="152" height="10"/>
				<textElement>
					<font size="7" isBold="false"/>
				</textElement>
				<textFieldExpression><![CDATA[$F{origem}]]></textFieldExpression>
			</textField>
		</band>
	</detail>
	<columnFooter>
		<band splitType="Stretch"/>
	</columnFooter>
	<pageFooter>
		<band height="10" splitType="Stretch">
			<textField pattern="EEE, d MMM yyyy HH:mm:ss">
				<reportElement uuid="8a72f3d4-7e43-4813-b01e-4f459dfca155" x="0" y="0" width="100" height="10"/>
				<textElement>
					<font size="7"/>
				</textElement>
				<textFieldExpression><![CDATA[new Date()]]></textFieldExpression>
			</textField>
			<textField>
				<reportElement uuid="74633861-a977-4b3d-a760-9bb44c44e97c" x="453" y="0" width="90" height="10"/>
				<textElement textAlignment="Right">
					<font size="7"/>
				</textElement>
				<textFieldExpression><![CDATA["Página "+$V{PAGE_NUMBER}+" de"]]></textFieldExpression>
			</textField>
			<textField evaluationTime="Report">
				<reportElement uuid="39247741-099f-4a26-8891-a18d30bdb84e" x="543" y="0" width="12" height="10"/>
				<textElement>
					<font size="7"/>
				</textElement>
				<textFieldExpression><![CDATA[" " + $V{PAGE_NUMBER}]]></textFieldExpression>
			</textField>
			<line>
				<reportElement uuid="6797bea8-3aff-4169-aa5f-c1ed4f031c85" x="0" y="0" width="555" height="1"/>
				<graphicElement>
					<pen lineWidth="0.5"/>
				</graphicElement>
			</line>
		</band>
	</pageFooter>
	<summary>
		<band splitType="Stretch"/>
	</summary>
</jasperReport>
